#include <iostream>

#include <iostream>
#include <cstdlib>
 
using namespace std;
 
class Array1D
{
private:
	int* arr1;
	int len1;
public:
	Array1D(int n = 0) : len1(n)
	{
		arr1 = new int[n];
		int i=0;
		for(i=0; i<n; i++)
		{
			printf("[1] arr1 new   %x    %d   len:%d\n", &arr1[ i], i, len1);
		}
	}
	// " " ϵ սô.
	void deep_copy(const Array1D &orig) 
	{
		len1 = orig.len1;	//   
		arr1 = new int[len1];	// ޸𸮸  Ҵ 
		printf("[deep_copy] arr1 new    %x\n", arr1);
		for (size_t i=0; i<len1; i++) 
		{
			arr1[i] = orig.arr1[i];	//  鼭 ͸  մϴ.
			printf("[deep_copy]   %x    %d   len:%d\n", &arr1[ i], i, len1);
		}
	}
	//  縦 ϴ  ڰ ʿմϴ.
	Array1D &operator=(const Array1D &rhs) 
	{
		printf("operator=   this  :  %x\n", this);

		if (this == &rhs)	// ڱ ڽ ϴ 
			return *this;	//  ȯմϴ.
 
		delete[] arr1;	//  ҴǾ ޸𸮴 մϴ.
		deep_copy(rhs);
		return *this;
	}
	// ϴ 迡,  縦 ϴ  ڵ  ô.
	Array1D(const Array1D &orig) :arr1(NULL) 
	{
		printf("\n");
		deep_copy(orig);
	}
	int& operator[](int index)
	{
		if (index < 0 || index >= len1)
		{
			cout << "Out of index range" << endl;
			exit(0);
		}
		return *(&arr1[index]);
	}
	int Getlen()
	{
		return len1;
	}
	~Array1D()
	{
		cout << "Array1" << endl;
		delete[]arr1;
	}
};
 
class Array2D
{
private:
	Array1D* arr2;
	int len;
public:
	Array2D(int n1, int n2) :len(n1)
	{
		arr2 = new Array1D[n1];
		printf("arr2 new   %x\n", arr2);
		for (int i = 0; i < n1; i++)
		{
			arr2[i] = Array1D(n2);
			printf("&arr2[i] Array1D()   %x\n", &arr2[i]);
		}
			/*
			 ڵ带 ָ .
			  ڰ ǵ , Ʈ    Դϴ.
			Array1D(n2) arr1 ʵ( Ҵ 迭) arr2[i] ״ ԵǴ .
			 Array1D ӽ ü  Ҹϸ鼭 ҴǾ int 迭  ҸѴٴ ̴ϴ.
			  arr2[i] arr1 ʵ ̹  迭 ޸𸮸  ˴ϴ.
			 ū    и  Ȳ̰, ̴ Ư array[i] ü  
			MSVC  尡  ޸  ° delete Ƴ  ޽  Դϴ.
 
			  ذϷ    ó  ڰ  縦 ϰ  մϴ.
			 Ұ ʾ  Array2D    ִµ, Array2D   
			( +  )  ¥     帮ڽϴ. :)
 
			. C++11  ̿ϸ  ϰ ذ  ֽϴ.
			move semantic, shared_ptr, array ̳  ߰Ǿŵ.
			*/
	}
	Array1D& operator[](int index)
	{
		if (index < 0 || index >= len)
		{
			cout << "Out of index range" << endl;
			exit(0);
		}
		return *(&arr2[index]);
	}
	int Getlen()
	{
		return len;
	}
	~Array2D()
	{
		cout << "Array2" << endl;
		delete[]arr2;
	}
};
 
int MAX_X = 4;
int MAX_Y = 2;
 
int main(int argc, char** argv)
{
	Array2D arr(MAX_X, MAX_Y);
 
	for (int k = 0; k < MAX_X; k++)
	{
		for (int p = 0; p < MAX_Y; p++)
		{
			arr[k][p] = 1;
			printf("main    %x  %x  %d\n", &arr[k], &arr[k][p], arr[k][p]);
		}
	}
	cout << arr[1][1] << endl;


	return 0;
}




#if 0

2, 4  

arr2 new   3d3f2c
[1] arr1 new   3d3a68    0   len:4
[1] arr1 new   3d3a6c    1   len:4
[1] arr1 new   3d3a70    2   len:4
[1] arr1 new   3d3a74    3   len:4
operator=   this  :  3d3f2c
[deep_copy] arr1 new    3d3ab8
[deep_copy]   3d3ab8    0   len:4
[deep_copy]   3d3abc    1   len:4
[deep_copy]   3d3ac0    2   len:4
[deep_copy]   3d3ac4    3   len:4
Array1
&arr2[i] Array1D()   3d3f2c
[1] arr1 new   3d3a68    0   len:4
[1] arr1 new   3d3a6c    1   len:4
[1] arr1 new   3d3a70    2   len:4
[1] arr1 new   3d3a74    3   len:4
operator=   this  :  3d3f34
[deep_copy] arr1 new    3d3f68
[deep_copy]   3d3f68    0   len:4
[deep_copy]   3d3f6c    1   len:4
[deep_copy]   3d3f70    2   len:4
[deep_copy]   3d3f74    3   len:4
Array1
&arr2[i] Array1D()   3d3f34
main    3d3f2c  3d3ab8  1
main    3d3f2c  3d3abc  1
main    3d3f2c  3d3ac0  1
main    3d3f2c  3d3ac4  1
main    3d3f34  3d3f68  1
main    3d3f34  3d3f6c  1
main    3d3f34  3d3f70  1
main    3d3f34  3d3f74  1
1
Array2
Array1
Array1

--------------------------------
Process exited after 0.7167 seconds with return value 0
Ϸ ƹ Ű ʽÿ . . .



4, 2  


arr2 new   3d3f2c
[1] arr1 new   3d3f98    0   len:2
[1] arr1 new   3d3f9c    1   len:2
operator=   this  :  3d3f2c
[deep_copy] arr1 new    3d3f58
[deep_copy]   3d3f58    0   len:2
[deep_copy]   3d3f5c    1   len:2
Array1
&arr2[i] Array1D()   3d3f2c
[1] arr1 new   3d3f98    0   len:2
[1] arr1 new   3d3f9c    1   len:2
operator=   this  :  3d3f34
[deep_copy] arr1 new    3d3f68
[deep_copy]   3d3f68    0   len:2
[deep_copy]   3d3f6c    1   len:2
Array1
&arr2[i] Array1D()   3d3f34
[1] arr1 new   3d3f98    0   len:2
[1] arr1 new   3d3f9c    1   len:2
operator=   this  :  3d3f3c
[deep_copy] arr1 new    3d3f78
[deep_copy]   3d3f78    0   len:2
[deep_copy]   3d3f7c    1   len:2
Array1
&arr2[i] Array1D()   3d3f3c
[1] arr1 new   3d3f98    0   len:2
[1] arr1 new   3d3f9c    1   len:2
operator=   this  :  3d3f44
[deep_copy] arr1 new    3d3f88
[deep_copy]   3d3f88    0   len:2
[deep_copy]   3d3f8c    1   len:2
Array1
&arr2[i] Array1D()   3d3f44
main    3d3f2c  3d3f58  1
main    3d3f2c  3d3f5c  1
main    3d3f34  3d3f68  1
main    3d3f34  3d3f6c  1
main    3d3f3c  3d3f78  1
main    3d3f3c  3d3f7c  1
main    3d3f44  3d3f88  1
main    3d3f44  3d3f8c  1
1
Array2
Array1
Array1
Array1
Array1

--------------------------------
Process exited after 0.9612 seconds with return value 0
Ϸ ƹ Ű ʽÿ . . . 


#endif







